class Reader (object):
	def __init__ (self,obj):
		self.seen = ""
		if type(obj) == type(""):
			self.next = 0
			self.string = obj
			
			self.read_char = self.string_read_char
			self.read_int = self.string_read_int
			self.read_str = self.string_read_str
			self.read_eof = self.string_read_eof
		else:
			self.fo = obj
			
			self.read_char = self.fo_read_char
			self.read_int = self.fo_read_int
			self.read_str = self.fo_read_str
			self.read_eof = self.fo_read_eof
	
	def string_read_char (self):
		s = self.string[self.next]
		value = ord(s)
		self.seen += s
		self.next += 1
		return value
	
	def string_read_int (self):
		n = self.next
		value = int(ord(self.string[n])*256 + ord(self.string[n+1]))
		self.seen += self.string[n:n+2]
		self.next += 2
		return value

	def string_read_str (self):
		size = self.string_read_int()
		string = self.string[self.next:self.next+size]
		self.seen += string
		self.next += size
		return string

	def string_read_eof (self):
		string = self.string[self.next:]
		self.seen += string
		self.next += len(string)
		return string

	def fo_read_char (self):
		s = self.fo.read(1)
		value = ord(s)
		self.seen += s
		return value

	def fo_read_int (self):
		s = self.fo.read(2)
		value = int(ord(s[0])*256 + ord(s[1]))
		self.seen += s
		return value

	def fo_read_str (self):
		size = self.fo_read_int()
		if size:
			string = self.fo.read(size)
		else:
			string = ""
		self.seen += string
		return string

	def fo_read_eof (self):
		string = ''
		size = 0
		try:
			while True:
				r = self.fo.read(65535)
				if r == '':
					break
				string += r
		except:
			print "*********** ====================== DEBUG ME ===================== ******************"

		self.seen += string
		return string
